#
# spec file for package transmission (Version 1.74)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           transmission
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  gtk2-devel >= 2.6.0
BuildRequires:  intltool
BuildRequires:  libcurl-devel
BuildRequires:  libevent-devel
BuildRequires:  libnotify-devel
BuildRequires:  libqt4-devel
BuildRequires:  openssl-devel
BuildRequires:  update-desktop-files
Version:        1.74
Release:        4.8.1
Summary:        Lightweight, yet powerful BitTorrent client
Source:         http://download.m0k.org/transmission/files/%{name}-%{version}.tar.bz2
Source1:        transmission-qt.desktop
# PATCH-FIX-UPSTREAM transmission-no-dht.patch dimstar@opensuse.org -- fix build with --disable-dht
Patch0:         transmission-no-dht.patch
# PATCH-FIX-UPSTREAM transmission-CVE-2010-0012.patch vuntz@opensuse.org -- Taken from upstream
Patch1:         transmission-CVE-2010-0012.patch
# PATCH-FIX-UPSTREAM transmission-data-corruption-ticket1242.patch vuntz@opensuse.org -- Taken from upstream
Patch2:         transmission-data-corruption-ticket1242.patch
Url:            http://www.transmissionbt.com/
Group:          Productivity/Networking/Other
License:        GPLv2 ; MIT License (or similar)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       %{name}-common = %{version}
Provides:       %{name}-ui = %{version}

%description
Transmission is a fast, easy, and free multi-platform BitTorrent client
with a focus on being lightweight yet feature-filled. Its simple,
intuitive interface is designed to integrate tightly with whatever
computing environment you choose to use. Transmission strikes a balance
between providing useful functionality without feature bloat.
Furthermore, it is free for anyone to use or modify.

%package gtk
License:        GPLv2 ; MIT License (or similar)
Summary:        Lightweight, yet powerful BitTorrent client
Group:          Productivity/Networking/Other
Requires:       %{name}-common = %{version}
Provides:       %{name}-ui = %{version}

%description gtk
Transmission is a fast, easy, and free multi-platform BitTorrent client
with a focus on being lightweight yet feature-filled. Its simple,
intuitive interface is designed to integrate tightly with whatever
computing environment you choose to use. Transmission strikes a balance
between providing useful functionality without feature bloat.
Furthermore, it is free for anyone to use or modify.

This package contains a graphical user interface to transmission.

%package qt
License:        GPLv2 ; MIT License (or similar)
Summary:        Lightweight, yet powerful BitTorrent client
Group:          Productivity/Networking/Other
Requires:       %{name}-common = %{version}
Provides:       %{name}-ui = %{version}

%description qt
Transmission is a fast, easy, and free multi-platform BitTorrent client
with a focus on being lightweight yet feature-filled. Its simple,
intuitive interface is designed to integrate tightly with whatever
computing environment you choose to use. Transmission strikes a balance
between providing useful functionality without feature bloat.
Furthermore, it is free for anyone to use or modify.

This package contains a graphical user interface to transmission.

%package common
License:        GPLv2 ; MIT License (or similar)
Summary:        Lightweight, yet powerful BitTorrent client - Common Data
Group:          Productivity/Networking/Other
Requires:       %{name}-common-lang = %{version}
Requires:       %{name}-ui = %{version}
Obsoletes:      %{name}-lang <= %{version}
%if 0%{suse_version} > 1110
BuildArch:      noarch
%endif

%description common
Transmission is a fast, easy, and free multi-platform BitTorrent client
with a focus on being lightweight yet feature-filled. Its simple,
intuitive interface is designed to integrate tightly with whatever
computing environment you choose to use. Transmission strikes a balance
between providing useful functionality without feature bloat.
Furthermore, it is free for anyone to use or modify.

%lang_package -n %{name}-common
%prep
%setup -q
%patch0 -p1
%patch1 -p3
%patch2 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC"
export CXXFLAGS="$RPM_OPT_FLAGS -fPIC"
%configure \
        --disable-dht \
        --disable-static \
	--with-gtk
%__make %{?jobs:-j%{jobs}}
# the qt ui requires an extrawurst for now
cd qt
qmake qtr.pro
%__make %{?jobs:-j%{jobs}}

%install
%makeinstall
# install qt ui
cd qt
%__make install INSTALL_ROOT=%{buildroot}%{_prefix}
cd ..
%find_lang %{name}
%suse_update_desktop_file -r -N "Transmission" transmission Network P2P
%suse_update_desktop_file -i transmission-qt
%fdupes $RPM_BUILD_ROOT

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS NEWS README COPYING
%{_bindir}/transmission-daemon
%{_bindir}/transmission-remote
%{_bindir}/transmissioncli
%doc %{_mandir}/man1/transmission-daemon.1*
%doc %{_mandir}/man1/transmission-remote.1*
%doc %{_mandir}/man1/transmissioncli.1*

%files -n %{name}-common-lang -f %{name}.lang
%defattr(-,root,root)
# Not in filesystem, bnc#513962
##%if %suse_version <= 1110
# exclude locales which don't exist on old versions of openSUSE
%exclude %{_datadir}/locale/fil/LC_MESSAGES/*
##%endif

%files gtk
%defattr(-,root,root)
%doc AUTHORS NEWS README COPYING
%{_bindir}/transmission
%{_datadir}/applications/transmission.desktop
%doc %{_mandir}/man1/transmission.1*

%files qt
%defattr(-,root,root)
%doc AUTHORS NEWS README COPYING
%{_bindir}/qtr
%{_datadir}/applications/transmission-qt.desktop

%files common
%defattr(-,root,root)
%{_datadir}/transmission
%{_datadir}/icons/*/*/apps/transmission.*
%{_datadir}/pixmaps/transmission.png

%changelog
* Mon Mar 29 2010 vuntz@opensuse.org
- Add transmission-data-corruption-ticket1242.patch to fix
  potential data corruption. Fix bnc#589268.
- Thanks to Charles Kerr <charles@transmissionbt.com> for the
  backport.
* Mon Jan 11 2010 vuntz@opensuse.org
- Add transmission-CVE-2010-0012.patch to fix directory traversal.
  Fix bnc#568228.
* Sun Sep 27 2009 dimstar@opensuse.org
- Fix categories of transmission-qt, it appeared twice in the menu.
* Sat Sep  5 2009 dimstar@opensuse.org
- bnc#535391 - Add a desktop file for the Qt variant.
- Split the icons and webparts in a -common package, required by
  all variants.
- Rename the -lang package to -common-lang to reflect better where
  it belongs to.
- Obsolete transmission-lang by transmission-common.
* Tue Aug 25 2009 dimstar@opensuse.org
- Update to version 1.74:
  + All Platforms
  - Better data recovery in the case of an OS or Transmission
    crash
  - If a data file is moved, stop the torrent instead of
    redownloading it
  - Fix bug that didn't list some peers in the resume file and
    in PEX
  - More helpful torrent error messages
  - DHT now honors the bind-address-ipv4 configuration option
  - Fix Debian build error with miniupnpc
  - Fix Cygwin build error with strtold
  - Update to a newer snapshot of miniupnpc
  + Mac
  - 64-bit compatibility
  - Queuing system will not exclude transfers with tracker
    warnings
  - Links to original torrent files are no longer maintained
  - Fix bug where changing the global per-torrent peer connection
    limit did not affect the current session
  - Fix bug where changing settings through RPC would result in
    wrong values being saved for three fields
  + GTK+
  - Fix crash that occurred when adding torrents on some desktops
  - Synchronize the statusbar's and torrent list's speeds
  - Fix the Properties dialog's "Origin" field for multiple
    torrents
  + Qt
  - If Transmission was minimized, clicking on it the icon tray
    didn't raise it
  + Daemon
  - Speed Limit mode support added to transmission-remote
  - Add a "session stats" readout to transmission-remote
  +  Web Client
  - Progress bar shows seeding progress
  - Fix bug that displayed "%%nan" when verifying a torrent
  - "Pause All" only appeared to pause torrents with peers until
    refresh
  + Updated translations.
- Add transmission-no-dht.patch and --disable-dht in configure.
* Wed Aug 19 2009 beineri@opensuse.org
- Fix Name field of .desktop file and don't show up twice in menu.
* Sun Jul 19 2009 bjorn.lie@gmail.com
- Update to version 1.73:
  + All Platforms
  - Fix bug where user-configured peer limits could be exceeded
  - Use less memory in some high-peer situations
  - Better estimation of time left to download
  - Support supportcrypto and requirecrypto flags in http tracker
    announces
  - Update to newer snapshots of libnatpmp and miniupnpc
  - Make DHT a compile-time option
  + GTK+
  - Use GDK-safe versions of g_idle_add() and g_timeout_add*()
  - Save some space in GTK+ >= 2.16.0 by not building
    SexyIconEntry
  + Qt
  - Fix bug that crashed Qt client when setting alternative
    up/down speeds
  + Daemon
  - Add umask support
  + Web Client
  - Inspector and Add Torrent buttons for iPhone/iPod Touch
  - Add location field to inspector
  + CLI
  - Some torrent files created with transmission-cli were invalid
* Wed Jun 17 2009 vuntz@novell.com
- Update to version 1.72:
  + All Platforms
  - Fix 1.70 crash with assertion "tv->tv_usec >= 0"
  - Fix 1.70 crash with assertion "tr_peerIoSupportsFEXT(
    msgs->peer->io )"
  - Better DHT announce management
  - Fix error in reporting webseed counts via RPC
  - Better file preallocation on embedded systems
  + Mac
  - Fix problem where a small set of users could not add torrents
  + GTK+
  - Fix 1.70 crash when setting options in the Properties dialog
  - Fix a rare crash in desktop notifications
  - Can now sort the file list by priority, download, and
    completeness
  - Adding a torrent from a browser sometimes didn't work.
  - Various usability improvements
  + Daemon
  - Remote didn't always send the right Encoding header in
    requests
* Tue Jun  9 2009 vuntz@novell.com
- Update to version 1.71:
  + All Platforms
  - Fix 1.70 bug that caused high CPU use in high-peer swarms
  - Fix 1.70 build problems with DHT and libevent
  + Daemon
  - Fix watchdir issue on OSes that don't have inotify
  + GTK+
  - Fix 1.70 intltool build problem
  - Fix crash when the OS's stock mime-type icons are
    misconfigured
  - Handle very long torrent file lists faster
  + Web Client
  - Fix 1.70 bug where some torrents appeared to be duplicates
- Changes from version 1.70:
  + All Platforms
  - Distributed hash table (DHT) support for public torrents
  - Add option for moving and finding a torrent's data on the
    disk
  - JSON RPC messages can be ~85%% shorter, saving bandwidth and
    CPU
  - When available, use the system's copy of libevent instead of
    building one
  - Automatically pause torrents when verifying
  - Fix small bugs and memory leaks
  + Mac
  - Holding down the option key on launch will pause all
    transfers
  + Web Client
  - Big speed improvements, especially with large torrents
  - Fix 1.61 bug that broke adding torrents via the web client
  - Add the ability to upload multiple torrents at once
  - Torrents added by URL were always paused, regardless of
    preferences
  - Comments and announce addresses were cut off in the inspector
  - The "data remaining" field wasn't updated when the number
    reached 0
  - Smaller design adjustments
  + GTK+
  - Make it clearer that the status bar's ratio mode button is a
    button
  - Torrent comment box did not scroll, so long comments were
    partially hidden
  + Qt
  - Initial torrent list was sometimes incorrect
  - Add-torrent-and-delete-source deleted the source even if
    there was an error
  - Prefs dialog didn't show or modify "Stop seeding torrents at
    ratio"
- Add libevent-devel BuildRequires.
* Mon May 18 2009 vuntz@novell.com
- Update to version 1.61:
  + All Platforms
  - Close potential CSRF security hole for Web Client users
  - Fix locale error in the JSON parser
  + Qt
  - Various small bugfixes to the beta Qt client
  + Web Client
  - Fix 1.60 error when serving Web Client files on some embedded
    platforms
  - Add response header to allow clients to cache static files
  + Daemon
  - transmission-remote was unable to select torrents by their
    SHA1 hash
- Do not force CFLAGS and CXXFLAGS during compilation while they
  were set earlier.
- Do not add category to desktop file that is already there.
* Tue May  5 2009 opensuse@sukimashita.com
- Update to version 1.60:
  + All Platforms
  - Seed ratio limiting
  - Transfer prioritization
  - Option to specify if transfers are included in the global
    bandwidth limits
  - Random port, with optional randomization on startup
  - Improvements to UPnP port forwarding
  - Support for file preallocation on XFS filesystems
  + Mac
  - Requires Mac OS X 10.5 Leopard or newer
  - Groups (moved to preferences) can be auto-assigned to
    transfers when adding based on multiple criteria
  - Groups can have a default location when adding transfers
  - The speed limit scheduler can now be applied to only
    specific days
  - Bonjour support for the web interface
  - File filter field in the inspector
  - Option to include beta releases when auto-updating
    (using modified Sparkle 1.5)
  - Portuguese localization
  + Qt
  - New beta Qt client!
  + GTK+
  - Speed Limit: Second set of bandwidth limits that can be
    toggled or scheduled
  - Properties dialog now lets you edit/view multiple torrents
    at once
  - Allow sorting of the torrent list by size and by ETA
  - Show the file icon in the list
  + Daemon
  - Watch folder for auto-adding torrents
  - Many new features in the RPC/JSON interface
  - Allow users to specify a specific address when listening for
    peers
  + Web Client
  - File selection and prioritization
  - Add option to verify local data
  - Fix "Remove Data" bug
* Mon Apr 13 2009 mboman@suse.de
- Update to version 1.52:
  + GTK+ and Daemon
  * Always honor the XDG setting for the download directory
  + GTK+
  * Fix formatting error when showing speeds measured in MB/s
  * Fix bug that caused some scheduled speed limit time settings
    to be lost
  * Use the new blocklist URL when updating the blocklist
  + Web Client
  * On the server, better filtering of bad URLs
  * On the server, faster json serialization
  * Fix "Remove Data" bug
  * Fix minor web client 301 redirect error
  * Better Internet Explorer support
* Sat Feb 28 2009 vuntz@novell.com
- Update to version 1.51:
  + All Platforms
  - Fix configure script issues with non-gcc compilers and
    user-defined CFLAGS environment variables
  - Decrease CPU usage in some situations
  - Close a rare race condition on startup
  - More efficient use of libcurl when curl 7.18.0 or newer is
    present
  + GTK+
  - Play nicely with Ubuntu's new notification server
  - Add Pause All and Resume All buttons
  + Web Client
  - Support for Internet Explorer
  - Layout fixes when viewed on an iPhone/iPod touch
* Sun Feb 15 2009 mboman@suse.de
- Update to version 1.50:
  + All Platforms
  * IPv6 support for peers, and for trackers with explicit IPv6
    addresses
  * Improved connectivity for encrypted peers
  * Fix 1.42 error that made tracker announces slower over time
  * Fix a Mac-centric peer connection bug from 1.41
  * Use less CPU cycles when managing very fast peers
  * Better handling of non-UTF-8 torrent files
  * When removing local data, only remove data from the torrent
  * Close potential DoS vulnerability in 1.41
  * Many other bugfixes
  + GTK+
  * Various usability improvements
  * Better Gnome HIG compliance in the statusbar, properties
    dialog, and more
  + Daemon
  * Lots of new options added to transmission-remote
  * Fix 1.42 whitelist bug
  * Make i18n support optional for cli and daemon clients
  + CLI
  * Support session.json settings, just as the Daemon and GTK+
    clients do
  + Web Interface
  * Torrents can now be added by URL
  * Add the ability to "remove local data" from the web client
- Include web pages in the main package
* Tue Feb 10 2009 vuntz@novell.com
- Review changes.
* Mon Dec 29 2008 lmedinas@gmail.com
- Update to version 1.42:
  + Lot's of changes and bugfixes; see included NEWS file.
* Sat Dec 20 2008 mboman@suse.de
- Update to version 1.40:
  + All Platforms
  - Tracker communication uses fewer resources
  - More accurate bandwidth limits
  - Reduce disk fragmentation by preallocating files
  - Stability, security, and performance improvements to the RPC/Web UI
    server
  - Support compression when serving Web UI and RPC responses
  - Simplify the RPC whitelist
  - Fix bug that prevented handshakes with encrypted BitComet peers
  - Fix 1.3x bug that could re-download some data unnecessarily
  - Lazy bitfields
  + Mac
  - Option to automatically update the blocklist weekly
  - In the file inspector tab, show progress and size for folders
  - Scrollbars correctly appear when the main window auto-resizes
  - Sparkle updated to 1.5b6
  + GTK+
  - Option to automatically update the blocklist weekly
  - Added off-hour bandwidth scheduling
  - Simplify file/priority selection in the details dialog
  - Fix a couple of crashes
  + Web Client
  - The Web Client is now out of beta
  - Minor display fixes
  - On iPhone/iPod touch, launching from the home screen hides the address
    bar
  + Daemon
  - Added the ability to get detailed peer information on torrents
  - Fix bug that didn't handle --config-dir and TRANSMISSION_HOME correctly
  - Windows portability
  + Translation updates
* Tue Sep 23 2008 maw@suse.de
- Update to version 1.34:
  + All Clients:
  * Don't reconnect too frequently to the same peer
  * Webseed bugfix
  * Fix bug that caused some transfers to not be scraped
  * Handle OpenTracker's `downloaded' key in announce responses
  + GTK+
  * Minor display fixes
  * Updated translations
  + Daemon+:
  * Minor display fixes
  + Web Client:
  * Minor display fixes
  + CLI:
  * Fix crash when creating a torrent file.
* Fri Sep 12 2008 maw@suse.de
- Update to version 1.33:
  + Too many changes and bugfixes to list; see the included NEWS
    file.
* Fri Aug 22 2008 meissner@suse.de
- actually use optflags.
* Mon Apr 14 2008 vuntz@suse.de
- Update to version 1.11:
  + Fix a couple of minor display issues
* Fri Apr  4 2008 vuntz@suse.de
- Import from the build service, with cleanups.
* Thu Apr  3 2008 awafaa@opensuse.org 
- Initial build in new repository
- Create a .changes file
* Sat Mar 29 2008 Pascal Bleser <guru@unixtech.be> 1.10
- new upstream version
* Wed Feb 27 2008 Pascal Bleser <guru@unixtech.be> 1.06
- new upstream version
* Sat Feb  9 2008 Pascal Bleser <guru@unixtech.be> 1.05
- new upstream version
* Sat Feb  2 2008 Pascal Bleser <guru@unixtech.be> 1.04
- new upstream version
* Wed Jan 30 2008 Pascal Bleser <guru@unixtech.be> 1.03
- new upstream version
* Wed Jan 23 2008 Pascal Bleser <guru@unixtech.be> 1.02
- new upstream version
* Sat Jan 12 2008 Pascal Bleser <guru@unixtech.be> 1.01
- update to 1.01
* Sat Jan  5 2008 Pascal Bleser <guru@unixtech.be> 1.00
- update to 1.00
* Wed Jan  2 2008 Pascal Bleser <guru@unixtech.be> 0.96
- update to 0.96
* Wed Dec  5 2007 Pascal Bleser <guru@unixtech.be> 0.95
- update to 0.95
* Tue Nov 27 2007 Pascal Bleser <guru@unixtech.be> 0.94
- update to 0.94
* Tue Nov 13 2007 Pascal Bleser <guru@unixtech.be> 0.93
- update to 0.93
* Mon Oct 29 2007 Pascal Bleser <guru@unixtech.be> 0.91
- removed libevent BuildRequires, has an in-tree copy that is used anyway
- update to 0.91
* Thu Oct 25 2007 Pascal Bleser <guru@unixtech.be> 0.90
- lots of upstream cleanups, dropped patches
- gettext translations are now in the main package instead of in -gtk
- several binary renames
- man pages have been removed by upstream
- uses autotools now
- zsh completion has been removed by upstream
- update to 0.90
* Wed Oct  3 2007 Pascal Bleser <guru@unixtech.be> 0.82
- cli subpackage merged in (and provided by main package)
- gtk subpackage split out
- merged with Carlos Rodgriguez' transmission spec file
- moved to openSUSE Build Service
* Sun Sep 23 2007 Pascal Bleser <guru@unixtech.be> 0.82-0.pm.1
- moved to Packman
- new upstream version
* Tue Aug  7 2007 Pascal Bleser <guru@unixtech.be> 0.80-1
- new upstream version
* Tue May  1 2007 Pascal Bleser <guru@unixtech.be> 0.72-1
- now builds transmission daemon, proxy and remote
- new upstream version
* Tue Apr 24 2007 Pascal Bleser <guru@unixtech.be> 0.71-1
- new upstream version
* Wed Apr 18 2007 Pascal Bleser <guru@unixtech.be> 0.70-1
- new upstream version
* Fri Nov 10 2006 Pascal Bleser <guru@unixtech.be> 0.6.1-2
- added patch to disable broken gtk2 version test in configure, to build properly on 10.2beta with GTK2 2.10.x and enforce >= 2.6.0 through BuildRequires instead
* Tue Aug  8 2006 Pascal Bleser <guru@unixtech.be> 0.6.1-1
- new package
